
#include <SPI.h>          // библиотека для работы с шиной SPI
#include "nRF24L01.h"     // библиотека радиомодуля
#include "RF24.h"         // ещё библиотека радиомодуля

RF24 radio(9, 10); // "создать" модуль на пинах 9 и 10

byte address[][6] = {"1Node", "2Node", "3Node", "4Node", "5Node", "6Node"}; //возможные номера труб

byte counter;

int hose[4]; // массив данных для отправки

void setup() {
  Serial.begin(9600);         // открываем порт для связи с ПК

  radio.begin();              // активировать модуль
  radio.setAutoAck(1);        // режим подтверждения приёма, 1 вкл 0 выкл
  radio.setRetries(0, 15);    // (время между попыткой достучаться, число попыток)
  radio.enableAckPayload();   // разрешить отсылку данных в ответ на входящий сигнал
  radio.setPayloadSize(32);   // размер пакета, в байтах

  radio.openWritingPipe(address[0]);// мы - труба 3, открываем канал для передачи данных
  radio.openReadingPipe(0, address[1]);  // + открываем чтение сигнала
  radio.setChannel(0x80);             // выбираем канал (в котором нет шумов!)

  radio.setPALevel (RF24_PA_MAX);   // уровень мощности передатчика. На выбор RF24_PA_MIN, RF24_PA_LOW, RF24_PA_HIGH, RF24_PA_MAX
  radio.setDataRate (RF24_2MBPS); // скорость обмена. На выбор RF24_2MBPS, RF24_1MBPS, RF24_250KBPS
  //должна быть одинакова на приёмнике и передатчике!
  //при самой низкой скорости имеем самую высокую чувствительность и дальность!!

  radio.powerUp();        // начать работу
  radio.stopListening(); // прекращаем слушать эфир

  Serial.println("Started");  // оповещаем оператара, что живы

  //  прописываем входы сигналов от потенцеометров 
  pinMode (A0, INPUT); // локтевой сустав
  pinMode (A1, INPUT); // плечевой сустав "вверх - вниз"
  pinMode (A3, INPUT); // плечевой сустав "вперёд - назад"
}

void loop() {
  //  читаем сигнал потенцеометров
  hose[0] = map(analogRead(A0), 0, 1023, 325, 0);
  hose[1] = map(analogRead(A2), 0, 1023, 200, 0);
  hose[2] = map(analogRead(A1), 140, 500, 100, 0);
  

  int i = 0;
  while (i < 3){
    // защита сервоприводов от недопонимания
    if (hose[i] > 179){hose[i] = 179;}
    if (hose[i] < 1){hose[i] = 1;}

    i ++;
  }

  // радуем оператора, тем, что всё ещё живы
  Serial.print(190); Serial.print(" ");
  Serial.print(-10); Serial.print(" ");
  /*
  hose[0] = analogRead(A0);
  hose[1] = analogRead(A2);
  hose[2] = analogRead(A1); */

  i = 0;
  while (i < 3){
    Serial.print(hose[i]); Serial.print(" ");
    i ++;
  }
  Serial.println(" ");

  radio.write(&hose, sizeof(hose)); // отправляем данные

  delay(50); // задержка для корректной работы сервоприводов
}
