#include <SPI.h>          // библиотека для работы с шиной SPI
#include "nRF24L01.h"     // библиотека радиомодуля
#include "RF24.h"         // ещё библиотека радиомодуля
#include <Servo.h>

RF24 radio(9, 10); // "создать" модуль на пинах 9 и 10

byte address[][6] = {"1Node", "2Node", "3Node", "4Node", "5Node", "6Node"}; //возможные номера труб

byte counter;

int hose[4]; // входящий массив от перчатки

// прописываем, какие сервы хотим использывать
Servo servo_1;
Servo servo_2;
Servo servo_3;

void setup() {
  digitalWrite(8, HIGH); 
  pinMode(8, OUTPUT);

  Serial.begin(9600);         // открываем порт для связи с ПК

  radio.begin();              // активировать модуль
  radio.setAutoAck(1);        // режим подтверждения приёма, 1 вкл 0 выкл
  radio.setRetries(0, 15);    // (время между попыткой достучаться, число попыток)
  radio.enableAckPayload();   // разрешить отсылку данных в ответ на входящий сигнал
  radio.setPayloadSize(32);   // размер пакета, в байтах

  radio.openWritingPipe(address[1]);  // мы - труба 1, открываем канал для передачи данных
  radio.openReadingPipe(1, address[0]);  // + открываем чтение сигнала
  radio.setChannel(0x80);             // выбираем канал (в котором нет шумов!)

  radio.setPALevel (RF24_PA_MAX);   // уровень мощности передатчика. На выбор RF24_PA_MIN, RF24_PA_LOW, RF24_PA_HIGH, RF24_PA_MAX
  radio.setDataRate (RF24_2MBPS); // скорость обмена. На выбор RF24_2MBPS, RF24_1MBPS, RF24_250KBPS
  //должна быть одинакова на приёмнике и передатчике!
  //при самой низкой скорости имеем самую высокую чувствительность и дальность!!

  radio.powerUp();        // начать работу
  radio.startListening();  // начинаем слушать эфир

  Serial.println("Started");  // оповещаем оператара, что живы

  // прописываем пины, к которым подключены сервоприводы
  servo_1.attach(6);
  servo_2.attach(4);
  servo_3.attach(5);

}

void loop() {
  byte pipeNo, gotByte; // прописываем, что хотим слушать любую трубу

  if (radio.available(&pipeNo)) {        // слушаем эфир со всех труб
    radio.read(&hose, sizeof(hose));  // чиатем входящий сигнал

    // радуем оператора, тем, что всё ещё живы
    int i = 0;
    while (i < 4){
      Serial.print(hose[i]); Serial.print(" ");
      i ++;
    }
    if ((hose[0] > 180) or (hose[1] > 180) or (hose[2] > 180) or (hose[0] < 0) or (hose[1] < 0) or (hose[2] < 0)){Serial.println("reboot"); delay(100); digitalWrite(8, LOW); delay(100);}
    else{
      Serial.println(" "); 
      if ((hose[0] < 65) and (hose[1] < 160)){hose[0] = 65; hose[1] = 160;}
      if (hose[1] < 130){hose[1] = 130;}

      servo_1.write(hose[0]);
      servo_2.write(hose[1]);
      servo_3.write(hose[2]);
      /*servo_1.write(hose[5]);
      servo_2.write(hose[7]);*/
    }
  }

  delay(10); // задержка для радио
}
