#include <Servo.h>

Servo servo_glove;  //серва на пречатке
Servo servo_finger;  //серва для пальца

int min;  //мнимум сгиба пальца
int max;  //аналогично максимум

void setup() {
  Serial.begin(9600);

  servo_glove.attach(9);
  servo_finger.attach(10);
  
  pinMode(A0, INPUT);
  pinMode(A1, INPUT_PULLUP);

  servo_glove.write(0);
  servo_finger.write(180);

  while (digitalRead(A1) == 1)    //ждём нажатия на кнопку и запиминаем минимум
  min = analogRead(A0);

  Serial.println("OK");
  delay(200);

  servo_glove.write(180);
  servo_finger.write(60);

  while (digitalRead(A1) == 1)  //аналогично с максимумом
  max = analogRead(A0);

  Serial.println("OK");
}

int buf;  //буфер значений для обратной связи
int filter[3] = {0, 0, 0};  //массив для фильтрации значений

void loop() {
  int got = (analogRead(A0) + filter[0] + filter[1] + filter[2])/4;

  int glove = map(got, 150, 651, 0, 180);  //корректируем значения
  int finger = map(got, min, max, 180, 60);
  
  if (digitalRead(A1) == 0) {glove = buf;}   //при нажатии на кнопку останавливаем палец

  servo_glove.write(glove);
  servo_finger.write(finger);

  buf = glove - 10;   //обновление буфера
  if (buf < 0){buf = 0;}  //защита от технических непоняток

  
  int i = 2;
  while (i > 0){filter[i] = filter[i - 1]; i--;}
  filter[0] = analogRead(A0);
}
