#include <sanlexandro_find.h>
#include <Servo.h>
#include <HX710B.h>

int x;
int y;
int z;
int rotation = 0;
int Catch = 0;

const int forearam = 55; // длина предплечья манипулятора в мм
const int base_height = 40; // высота основания манипулятора в мм

double base_angle; // угол поворота сервы в основании
double up_down_angle; // угол повотота серв в предплечии
int rotation_angle; //угол поворота захвата
int catch_angle; //уголб отвечающий за сжатие/разжатие захвата

String memory[7];

bool debugging = false;
bool pressure = false;

// объявляем сервоприводы
Servo base_servo;
Servo up_down_servo;
Servo rotation_servo;
Servo catch_servo;

// объявляем датчики давления
HX710B pressure_sensor_1;
HX710B pressure_sensor_2;

void setup() {
  Serial.begin(57600);

  getMemory(memory, 7);
  setMemorySave(true);

  // объявляем порты сервоприводов
  base_servo.attach(11);
  up_down_servo.attach(10);
  rotation_servo.attach(9);
  catch_servo.attach(6);
  // переводим в начальное положение
  base_servo.write(90);
  up_down_servo.write(15);
  rotation_servo.write(90);
  catch_servo.write(180);
  //                    dout|sclk
  pressure_sensor_1.begin(3, 2);
  pressure_sensor_2.begin(5, 4);

  while (pressure_sensor_1.is_ready() == 0){Serial.println("pressure sensor 1 is not connected"); delay(30);}
  while (pressure_sensor_2.is_ready() == 0){Serial.println("pressure sensor 2 is not connected"); delay(30);}
}

double pythagorean_theorem(int forearam, int base_height){return sqrt(forearam*forearam + base_height*base_height);}

void loop() {
  if (Serial.available() > 0){
    double Oxy_projection;
    double length;

    Data data(Serial.readString());  //  Читаем её
    x = data.findInt("!x:", &memory[0]);
    y = data.findInt("!y:", &memory[1]);
    z = data.findInt("!z:", &memory[2]) - base_height;
    rotation = data.findInt("!rotation:", &memory[3]);
    Catch = data.findInt("!catch:", &memory[4]);
    debugging = data.findBool("!debugging:", &memory[5]);
    pressure = data.findBool("!pressure:", &memory[6]);

    if (debugging == true){ Serial.println("true");}

    if (Catch == 1){catch_angle = 170;}
    else if (Catch == 0){catch_angle = 10;}

    if (0 <= rotation <= 180){rotation_angle = rotation;}
    
    Oxy_projection = pythagorean_theorem(x, y);
    length = pythagorean_theorem(Oxy_projection, z);

    if ((length <= forearam) and (z >= base_height * -1)){
      base_angle = asin((x / Oxy_projection)) * 57.3;
      up_down_angle = asin((z / length)) * 57.3;
      if (base_angle < 0){base_angle = 90 + base_angle * -1;}
    }
    if (debugging == true){
      Serial.print("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
      Serial.print("x:"); Serial.print(x);Serial.print(" y:"); Serial.print(y);Serial.print(" z:");Serial.println(z);
      Serial.print("rotation_angle:");Serial.print(rotation_angle);Serial.print(" catch_angle:"); Serial.println(catch_angle);
      Serial.print("Oxy_projection:");Serial.print(Oxy_projection);Serial.print(" length:"); Serial.println(length);
      Serial.print("base_angle:");Serial.print(base_angle);Serial.print(" up_down_angle:"); Serial.println(up_down_angle);
    }
    else if (debugging == true){Serial.println("aboba");}

    if ((pressure_sensor_1.is_ready() == 1) and (pressure_sensor_2.is_ready() == 1) and (pressure == true)){
      Serial.print("pressure: ");
      Serial.print(pressure_sensor_1.pascal());
      Serial.print(" | ");
      Serial.println(pressure_sensor_2.pascal());
    }
  }
  base_servo.write(base_angle);
  up_down_servo.write(up_down_angle + 15);
  rotation_servo.write(rotation_angle);
  catch_servo.write(catch_angle);
}
// !x:15!y:15!z:40!rotation:90!catch:true!debugging:true